################################################
# E-Blah Bulliten Board Systems       Platinum #
################################################
# Copyright (c) 2001 - 2004 e-blah!            #
# All Rights Reserved.                         #
################################################

CoreLoad('Admin',1);

sub Admin {
	&is_admin;
	if($URL{'a'} eq '') { &AdminCenter; } # Make the process a little faster
	elsif($URL{'a'} eq 'bkup') { &BoardBackup; }
	elsif($URL{'a'} eq 'bkupstart') { &BKUPStart; }
	elsif($URL{'a'} eq 'boards' || $URL{'a'} eq 'cats') { &ManageBoards; }
	elsif($URL{'a'} eq 'repop') { &Repop; }
	elsif($URL{'a'} eq 'memgrps') { CoreLoad('Members'); &MemGrps; }
	elsif($URL{'a'} eq 'temp') { &Temp; }
	elsif($URL{'a'} eq 'temp2') { &Temp2; }
	elsif($URL{'a'} eq 'iplog') { &IPLog; }
	elsif($URL{'a'} eq 'errorlog') { &ErrorLog; }
	elsif($URL{'a'} eq 'clicklog') { &ClickLog; }
	elsif($URL{'a'} eq 'remem') { &Remem; }
	elsif($URL{'a'} eq 'killsids') { &KILLSID; }
	elsif($URL{'a'} eq 'version') { &Version; }
	elsif($URL{'a'} eq 'news') { &News; }
	elsif($URL{'a'} eq 'advipsearch') { CoreLoad('Members'); &IPSearch; }
	elsif($URL{'a'} eq 'remove') { CoreLoad('Moderate'); &OldThreads; }
	elsif($URL{'a'} eq 'portal') { CoreLoad('Portal'); &PortalAdmin; }
	elsif($URL{'a'} eq 'reserve') { &Reserve; }
		else { CoreLoad('Admin2'); &Admin2; } # Load Admin2
}

sub LoadModifications {
	# When you make a modification to Blah, add it here in the following format:
	  # - push(@bdmod,"My Modification Name");

	$ypon = $yabbconver ? $admintxt[2] : $admintxt[3]; # YaBB Security Mod
	push(@bdmod,"$admintxt[1] (<b>$ypon</b>)"); # YaBB Security Mod

	# End of editing ...
	foreach(@bdmod) { $bdmods .= "$_<br>"; }
	$bdmods =~ s/<br>\Z//;
}

sub AdminCenter {
	foreach(@admins) { push(@adminlist,FindRanks($_)); }
	foreach(@adminlist) { $adminlist .= qq~<a href="$scripturl,v=memberpanel,a=view,u=$_">$userset{$_}->[1]</a>, ~; }
	$adminlist =~ s/, \Z//;

	&LoadModifications;
	fopen(FILE,"$prefs/ReportPM.txt");
	@reports = <FILE>;
	fclose(FILE);
	chomp @reports;
	$reportpm = 0;
	foreach(@reports) {
		($t,$t,$t,$t,$t,$t,$t,$t,$recieveuser,$t,$t) = split(/\|/,$_);
		if($recieveuser eq $username || $recieveuser eq 'all admin') { ++$reportpm; }
	}

	$banninglog = 0;
	$activelog = 0;
	$clicklog = 0;
	$attlog = 0;
	$banlog = 0;
	$felog = 0;
	$areferals = 0;
	$referals = 0;
	$activesids = 0;
	$inactivesids = 0;

	fopen(FILE,"$prefs/ELog.txt");
	while(<FILE>) { ++$felog; }
	fclose(FILE);
	fopen(FILE,"$prefs/BanList.txt");
	while(<FILE>) { ++$banlog; }
	fclose(FILE);
	fopen(FILE,"$prefs/Attachments.txt");
	while(<FILE>) { ++$attlog; }
	fclose(FILE);
	fopen(FILE,"$prefs/ClickLog.txt");
	while(<FILE>) { ++$clicklog; }
	fclose(FILE);
	fopen(FILE,"$prefs/Active.txt");
	while(<FILE>) { ++$activelog; }
	fclose(FILE);
	fopen(FILE,"$prefs/NoAccess.txt");
	while(<FILE>) { ++$banninglog; }
	fclose(FILE);
	fopen(FILE,"$prefs/Refer.txt");
	while(<FILE>) { ++$areferals; }
	fclose(FILE);
	fopen(FILE,"$prefs/ReferLog.txt");
	while(<FILE>) { ++$referals; }
	fclose(FILE);
	fopen(FILE,"$prefs/Sids.sid");
	@sids = <FILE>;
	fclose(FILE);
	chomp @sids;
	foreach(@sids) {
		($t,$t,$t,$t,$endtime,$baccess) = split(/\|/,$_);
		if($endtime > time) { ++$activesids; } else { ++$inactivesids; }
	}
	if($inactivesids) { $inactivesidsq = qq~<br><a href="javascript:clear('$scripturl,v=admin,a=killsids')">$admintxt[4]</a>~; }

	opendir(DIR,"$theme/");
	@themes = readdir(DIR);
	closedir(DIR);
	CoreLoad("Themes");
	foreach(@themes) {
		if($_ =~ m/(.*)(.v2)/) {
			StopThemes("$theme/$_") || next;
			$themes .= qq~$name<br>~;
		}
	}
	$themes =~ s/<br>\Z//;
	if($themes eq '') { $themes = $admintxt[5]; }

	$systemstatus = $clicklog / $logcnt;
	if($activelog >= 0) { $systemstatus = $admintxt[166]; }
	if($activelog > 19 || ($clicklog / $logcnt) > 1.3) { $systemstatus = $admintxt[167]; }
	if($activelog > 39 || ($clicklog / $logcnt) > 5.5) { $systemstatus = $admintxt[165]; }
	if($felog) { $systemstatus .= " $admintxt[164]"; }

	$clicklog = MakeComma($clicklog);
	$logcnt = $logcnt > 59 ? sprintf("%.0f",($logcnt/60))." $gtxt{'3'}" : "$logcnt $gtxt{'2'}";

	if($URL{'r'} < 5 && $URL{'r'} > 0) {
		if($URL{'r'} == 1) { $r = $admintxt[77]; }
		if($URL{'r'} == 2) { $r = $admintxt[145]; }
		if($URL{'r'} == 3) { $r = $admintxt[169]; }
		if($URL{'r'} == 4) { $r = $admintxt[170]; }

		$message = <<"EOT";
<table bgcolor="$color{'border'}" class="border" cellpadding="4" cellspacing="1" width="750" align="center">
 <tr>
  <td bgcolor="$color{'win'}" class="win" width="100%" align="center"><font size="1" class="smalltext"><b>$r</b></font></td>
 </tr>
</table><br>
EOT
	}

	$title = $admintxt[6];
	&header;
	print <<"EOT";
<script language="javascript">
<!-- //
function clear(url,url2,explain) {
 if(!explain) { explain = "$admintxt[7]"; }
 if(window.confirm(explain)) { location = url; }
  else {
   if(url2) { location = url2; }
  }
}
// -->
</script>
$message
<table bgcolor="$color{'border'}" class="border" cellpadding="4" cellspacing="1" width="750" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg" colspan="2"><b><img src="$images/admin_sm.gif"> $title</b></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win" colspan="2">
  <table cellpadding="2" cellspacing="0">
   <tr>
    <td width="50%" align="center"><font size="1" class="smalltext"><b>$mbname :: $title<hr color="$color{'border'}" class="hr" size="1"><font size="1" class="smalltext"><b>$date_time<br><img src="$images/keys.gif"> $admintxt[8]<br>$admintxt[9]: $pmcnt ($new $admintxt[10])</font></b></font></td>
    <td width="50%"><font size="1" class="smalltext">$admintxt[11], <b>$settings[1]</b>! $admintxt[12] <a href="http://www.eblah.com/cgi-bin/bb/Blah.pl?,v=mindex,b=btech">$admintxt[13]</a>.</font></td>
   </tr>
  </table>
  </td>
 </tr>
</table><br>
<table cellpadding="0" cellspacing="0" width="750" align="center">
 <tr>
  <td valign="top">
   <table bgcolor="$color{'border'}" class="border" cellpadding="4" cellspacing="1" width="372">
    <tr>
     <td bgcolor="$color{'catbg'}" class="catbg"><b><img src="$images/open_thread.gif"> $admintxt[14]</b></td>
    </tr><tr>
     <td bgcolor="$color{'win'}" class="win" valign="top">
      <table cellpadding="1" cellspacing="0" width="100%">
       <tr>
        <td width="50%"><font size="1" class="smalltext"><b>&#149;  <a href="$scripturl,v=admin,a=sets">$admintxt[16]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=boards">$admintxt[43]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=smiley">$admintxt[44]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=censor">$admintxt[46]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=portal">$admintxt[168]</a><br>
        </td><td width="50%"><font size="1" class="smalltext"><b>&#149;  <a href="$scripturl,v=admin,a=themesman">$admintxt[47]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=advipsearch">$admintxt[48]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=news">$admintxt[49]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=sourcemod">$admintxt[50]</a></b><br><br></font></td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" class="catbg" valign="top"><b><img src="$images/xx.gif"> $admintxt[51]</b</td>
    </tr><tr>
     <td bgcolor="$color{'win2'}" class="win2"  valign="top"><font size="1" class="smalltext"><b>
     &#149;  <a href="$scripturl,v=admin,a=temp">$admintxt[52]</a><br>
     &#149;  <a href="$scripturl,v=admin,a=regtemp">$admintxt[53]</a></b></font></td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" class="catbg" valign="top"><b><img src="$images/profile_sm.gif"> $admintxt[54]</b></td>
    </tr><tr>
     <td bgcolor="$color{'win'}" class="win"  valign="top">
      <table cellpadding="1" cellspacing="0" width="100%">
       <tr>
        <td width="50%"><font size="1" class="smalltext"><b>
        &#149;  <a href="$scripturl,v=admin,a=memgrps">$admintxt[55]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=reports">$admintxt[56]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=mailing">$admintxt[58]</a></b> (<b><a href="$scripturl,v=admin,a=mailing,s=all">All</a></b>)</font></td>
        <td width="50%" valign="top"><font size="1" class="smalltext"><b>
        &#149;  <a href="$scripturl,v=admin,a=removemembers">$admintxt[62]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=ban">$admintxt[45]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=validate">$admintxt[63]</a></b></font></td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" class="catbg" valign="top"><b><img src="$images/mem_main.gif"> $admintxt[59]</b></td>
    </tr><tr>
     <td bgcolor="$color{'win2'}" class="win2" valign="top">
      <table cellpadding="1" cellspacing="0" width="100%">
       <tr>
        <td width="50%"><font size="1" class="smalltext"><b>&#149;  <a href="javascript:clear('$scripturl,v=admin,a=remem')">$admintxt[60]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=delspec">$admintxt[61]</a><br>

        &#149;  <a href="$scripturl,v=admin,a=reserve">$admintxt[171]</a>
        </td><td width="50%" valign="top"><font size="1" class="smalltext"><b>     &#149;  <a href="javascript:clear('$scripturl,v=admin,a=posts','','$admintxt[159]')">$admintxt[160]</a><br></b></font></td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" class="catbg" valign="top"><b><img src="$images/brd_main.gif"> $admintxt[64]</b></td>
    </tr><tr>
     <td bgcolor="$color{'win'}" class="win" valign="top"><font size="1" class="smalltext"><b>
      &#149;  <a href="$scripturl,v=admin,a=repop">$admintxt[65]</a><br>
      &#149;  <a href="$scripturl,v=admin,a=bkup">$admintxt[66]</a><br>
      &#149;  <a href="$scripturl,v=admin,a=remove">$admintxt[67]</a></b></font></td>
     </td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" class="catbg" valign="top"><b><img src="$images/clicklog_sm.gif"> $admintxt[68]</b></td>
    </tr><tr>
     <td bgcolor="$color{'win2'}" class="win2" valign="top">
      <table cellpadding="1" cellspacing="0" width="100%">
       <tr>
        <td width="50%"><font size="1" class="smalltext"><b>&#149;  <a href="$scripturl,v=admin,a=attlog">$admintxt[69]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=banlog">$admintxt[70]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=clicklog">$admintxt[71]</a><br>
        </td><td width="50%"><font size="1" class="smalltext"><b>&#149;  <a href="$scripturl,v=admin,a=errorlog">$admintxt[72]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=iplog">$admintxt[73]</a><br>
        &#149;  <a href="$scripturl,v=admin,a=referals">$admintxt[74]</a></b></font></td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" class="catbg" valign="top"><b><img src="$images/convert.gif"> $admintxt[75]</b></td>
    </tr><tr>
     <td bgcolor="$color{'win'}" class="win" valign="top"><font size="1" class="smalltext"><b>&#149;  <a href="$surl,v=admin,a=convert,t=yabb">YaBB</a></b></font></td>
    </tr>
   </table>
  </td>
  <td valign="top" align="right">
   <table bgcolor="$color{'border'}" class="border" cellpadding="4" cellspacing="1" width="372">
    <tr>
     <td bgcolor="$color{'catbg'}" class="catbg"><b><img src="$images/lamp.gif"> $admintxt[15]</b></td>
    </tr><tr>
     <td bgcolor="$color{'win2'}" class="win2">
      <table cellpadding="2" cellspacing="0" width="100%">
       <tr>
        <td align="right" width="45%" valign="top"><font size="1" class="smalltext"><b>$admintxt[17]:</b></font></td>
        <td><font size="1" class="smalltext">$regto (<a href="mailto:$eadmin">e-mail</a>)</font></td>
       </tr><tr>
        <td colspan="2"><hr color="$color{'border'}" class="hr" size="1"></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><font size="1" class="smalltext"><b>$admintxt[18]:</b></font></td>
        <td valign="top"><font size="1" class="smalltext">$adminlist</font></td>
       </tr><tr>
        <td colspan="2" align="center"><font size="1" class="smalltext"><b><a href="$scripturl,v=members,a=groups">$admintxt[19]</a></b></font></td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" class="catbg"><b><img src="$images/ip.gif"> $admintxt[161]</b></td>
    </tr><tr>
     <td bgcolor="$color{'win'}" class="win">
      <table cellpadding="2" cellspacing="1" width="100%">
       <tr>
        <td align="right" valign="top" colspan="2"><font size="1" class="smalltext"><b>$admintxt[163] ($logcnt):</b></font></td>
        <td valign="top" colspan="2"><font size="1" class="smalltext">$systemstatus</font></td>
       </tr><tr>
        <td colspan="4"><hr color="$color{'border'}" class="hr" size="1"></td>
       </tr><tr>
        <td width="15%" align="right"><font size="1" class="smalltext"><a href="$scripturl,v=admin,a=clicklog">$clicklog</a></font></td>
        <td width="35%"><font size="1" class="smalltext"><b>$admintxt[20]</b></font></td>
        <td width="10%" align="right"><font size="1" class="smalltext"><a href="$scripturl,v=admin,a=reports">$reportpm</a></font></td>
        <td width="40%"><font size="1" class="smalltext"><b>$admintxt[21]</b></font></td>
       </tr><tr>
        <td align="right"><font size="1" class="smalltext"><a href="$scripturl,v=stats,a=whereis">$activelog</a></font></td>
        <td><font size="1" class="smalltext"><b>$admintxt[22]</b></font></td>
        <td align="right"><font size="1" class="smalltext"><a href="$scripturl,v=admin,a=attlog">$attlog</a></font></td>
        <td><font size="1" class="smalltext"><b>$admintxt[24]</b></font></td>
       </tr><tr>
        <td align="right"><font size="1" class="smalltext"><a href="$scripturl,v=admin,a=ban">$banlog</a></font></td>
        <td><font size="1" class="smalltext"><b>$admintxt[25]</b></font></td>
        <td align="right"><font size="1" class="smalltext"><a href="$scripturl,v=admin,a=errorlog">$felog</a></font></td>
        <td><font size="1" class="smalltext"><b>$admintxt[26]</b></font></td>
       </tr><tr>
        <td colspan="4"><hr color="$color{'border'}" class="hr" size="1"></td>
       </tr><tr>
        <td align="right"><font size="1" class="smalltext"><a href="$scripturl,v=admin,a=banlog">$banninglog</a></font></td>
        <td><font size="1" class="smalltext"><b>$admintxt[27]</b></font></td>
        <td align="right"><font size="1" class="smalltext"><a href="$scripturl,v=admin,a=referals">$areferals</a></font></td>
        <td><font size="1" class="smalltext"><b>$admintxt[28]</b></font></td>
       </tr><tr>
        <td align="right"><font size="1" class="smalltext"><a href="$scripturl,v=admin,a=referals">$referals</a></font></td>
        <td><font size="1" class="smalltext"><b>$admintxt[29]</b></font></td>
        <td align="right"><font size="1" class="smalltext">$activesids</font></td>
        <td><font size="1" class="smalltext"><b>$admintxt[30]</b></font></td>
       </tr><tr>
        <td align="right" valign="top"><font size="1" class="smalltext">$inactivesids</font></td>
        <td colspan="3"><font size="1" class="smalltext"><b>$admintxt[31]</b>$inactivesidsq</font></td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" class="catbg"><b><img src="$images/thumbup.gif"> $admintxt[162]</b></td>
    </tr><tr>
     <td bgcolor="$color{'win2'}" class="win2" align="center">
      <table cellpadding="2" cellspacing="0" width="100%">
       <tr>
        <td align="right" width="45%" valign="top"><font size="1" class="smalltext"><b>$admintxt[32]:</b></font></td>
        <td valign="top"><font size="1" class="smalltext">$bdmods</font></td>
       </tr><tr>
        <td align="center" colspan="2"><font size="1" class="smalltext"><b><a href="$scripturl,v=admin,a=sourcemod">$admintxt[50]</a></b></font></td>
       </tr><tr>
        <td align="right" width="45%" valign="top"><font size="1" class="smalltext"><b>$admintxt[34]:</b></font></td>
        <td valign="top"><font size="1" class="smalltext">$themes</font></td>
       </tr><tr>
        <td align="center" colspan="2"><font size="1" class="smalltext"><b><a href="$scripturl,v=admin,a=themesman">$admintxt[47]</a></b></font></td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td bgcolor="$color{'catbg'}" class="catbg"><b><img src="$images/question.gif"> $admintxt[146]</b></td>
    </tr><tr>
     <td bgcolor="$color{'win'}" class="win" align="center">
      <table cellpadding="2" cellspacing="0" width="100%"><tr>
        <td align="right" width="45%" valign="top"><font size="1" class="smalltext"><b>$admintxt[35]:</b></font></td>
        <td valign="top"><font size="1" class="smalltext">$version</font></td>
       </tr><td colspan="2" align="center"><font size="1" class="smalltext"><b><a href="$scripturl,v=admin,a=version">$admintxt[36]</a></font></td></tr>
      </table>
     </td>
    </tr>
   </table>
  </td>
 </tr>
</table>
<table align="center" width="600">
 <tr>
  <td valign="bottom" align="center" colspan="2"><br>
   <table bgcolor="$color{'border'}" class="border" cellpadding="0" cellspacing="1" width="100%">
    <tr>
     <td bgcolor="$color{'catbg'}" class="catbg"><table cellpadding="4" cellspacing="0" width="100%"><tr><td align="center"><font size="1" class="smalltext"><b>$admintxt[37]</b></font></td></tr></table></td>
    </tr><tr>
     <td bgcolor="$color{'win2'}" class="win2" align="center">
      <table cellpadding="4" cellspacing="0" width="100%">
       <tr>
        <td align="right" width="35%" valign="top"><span style="cursor:default;"><font size="1" class="smalltext"><b>$admintxt[38]:</b></font></span></td>
        <td valign="top"><font size="1" class="smalltext"><span style="cursor:hand;"><b>Jesus</b>, <a title="Allowing me to switch them from Gamers.com to Blah">JFA</a>, <a title="Their support of the Blah Project">FP Community</a>, <a title="Thanks for the eblah.com domain! :D">superfalon</a>, <a title="Justin's baby :D">Jennifer</a>, Beta Testers</span></font></td>
       </tr><tr>
        <td align="right" width="35%" valign="top" bgcolor="$color{'win'}" class="win"><span style="cursor:default;"><font size="1" class="smalltext"><b>$admintxt[39]:</b></font></span></td>
        <td valign="top" bgcolor="$color{'win'}" class="win"><font size="1" class="smalltext"><span style="cursor:default;">Justin</span></font></td>
       </tr><tr>
        <td align="right" width="35%" valign="top"><span style="cursor:default;"><font size="1" class="smalltext"><b>$admintxt[40]:</b></font></span></td>
        <td valign="top"><font size="1" class="smalltext"><span style="cursor:hand;"><a title="Helped a little with Attachments, various file opening routines, and text to URL.">Dave B.</a>, <a title="Did the help that I was too lazy to do. ;D">DeathBox</a>, <a title="Found some bugs for me. :) Thanks!!">CLiX</a>, Tony</span></font></td>
       </tr><tr>
        <td colspan="2" bgcolor="$color{'win'}" class="win"><font size="1" class="smalltext"><center><b>True Life: It is as simple as A - B - C</b></center><b>A:</b> Admit that you are a <b>sinner</b> and that you need a <b>savior</b>.<br><b>B:</b> Believe in your heart that <b>Jesus Christ is Lord</b>.<br><b>C: Confess</b> your sins and <b>commit your life to him</b>.<br><b>D: Do not wait</b> until tomorrow.</font></td>
       </tr>
      </table>
     </td>
    </tr>
   </table>
  </td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub KILLSID {
	fopen(FILE,"$prefs/Sids.sid");
	while( $sid = <FILE> ) {
		chomp $sid;
		($tsid,$ip,$sidname,$t,$endtime) = split(/\|/,$sid);
		if($endtime > time) { $othersids .= "$sid\n"; }
	}
	fclose(FILE);
	fopen(FILE,"+>$prefs/Sids.sid");
	print FILE $othersids;
	fclose(FILE);
	redirect("$scripturl,v=admin,r=3");
}

sub Remem {
	opendir(DIR,"$members/");
	@list = readdir(DIR);
	closedir(DIR);
	$memcnt = 0;
	foreach (sort @list) {
		if($_ =~ s/.dat\Z//) {
			&loaduser($_);
			if($userset{$_}->[14] > $lucnt) {
				$luser = $_;
				$lucnt = $userset{$_}->[14];
			}
			if($userset{$_}->[1]) { ++$memcnt; $memlistc .= "$_\n"; }
		}
	}
	fopen(LIST,"+>$members/List.txt");
	print LIST "$memlistc";
	fclose(LIST);
	fopen(FILE,"+>$members/LastMem.txt");
	print FILE "$luser\n$memcnt";
	fclose(FILE);
	if($URL{'v'} eq 'memberpanel' || $URL{'a'} eq 'convert' || $URL{'a'} eq 'delspec' || $URL{'a'} eq 'removemembers') { return; }

	redirect("$scripturl,v=admin,r=1");
}

sub ClickLog {
	if($eclick != 1) { &error($admintxt[78]); }
	if($URL{'p'} eq 'delete') {
		fopen(FILE,">$prefs/ClickLog.txt");
		print FILE '';
		fclose(FILE);
		redirect("$scripturl,v=admin,r=3");
	}

	$title = $admintxt[79];
	&header;
	print <<"EOT";
<script language="javascript">
<!-- //
function clear(url) {
 if(window.confirm("$admintxt[80]")) { location = url; }
}
// -->
</script>
<table bgcolor="$color{'border'}" class="border" cellpadding="4" cellspacing="1" align="center" width="750">
 <tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg" colspan="6"><b><img src="$images/clicklog_sm.gif"> $title</b></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win" colspan="6"><font size="1" class="smalltext">$admintxt[81]<b><a href="$scripturl,v=admin,a=sets,l=log">$admintxt[82]</a></b>.</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" class="catbg" colspan="6"><b>&#149; $admintxt[84]<font size="1" class="smalltext"> ($admintxt[83])</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win" colspan=6>
   <table cellpadding="3" cellspacing="0" width="100%">
EOT
	$totalips = 0;
	$counter = 0;
	fopen(FILE,"$prefs/ClickLog.txt");
	while(<FILE>) {
		chomp;
		($logtime,$ipaddy,$ref[$totalips],$page[$totalips],$info[$totalips]) = split(/\|/,$_);
		if($iplog{$ipaddy} eq '') {
			push(@ipaddyt,"$ipaddy");
			$iplog{$ipaddy} = 1;
		} else { ++$iplog{$ipaddy}; }
		if($page[$totalips] eq '') { $page[$totalips] = $admintxt[85]; }
		++$totalips;
	}
	fclose(FILE);
	if(!$totalips) { $totalips = 1; }

	foreach(@ipaddyt) { push(@ipaddy,"$iplog{$_}|$_"); }

	foreach(sort{$b <=> $a} @ipaddy) {
		($t,$ip) = split(/\|/,$_);
		$pper = ($iplog{$ip}/$totalips);
		$pper = sprintf("%.2f",($pper*100));
		print <<"EOT";
    <tr>
     <td align=right width="25%"><b><a href="$scripturl,v=admin,a=advipsearch,s=advsearch,ip=$ip" title="$admintxt[86]">$ip</a></b> </td>
     <td width="50%"><img src="$images/bar.gif" width="$pper%" height="10" alt="$pper%"></td>
     <td width="25%"><font size="1" class="smalltext"> $iplog{$ip} $admintxt[87] ($pper%)</font></td>
    </tr>
EOT
		++$counter;
	}
		print <<"EOT";
    <tr>
     <td width=75% colspan=2 align=right><b>$admintxt[88]: </b></td>
     <td width=25%><font size="1" class="smalltext"> $totalips $admintxt[87]</font></td>
    </tr><tr>
     <td width=75% colspan=2 align=right><b>$admintxt[89]: </b></td>
     <td width=25%><font size="1" class="smalltext"> $counter $admintxt[90]</font></td>
    </tr>
EOT
	$cntb = 0;
	$cnto = 0;
	for($i = 0; $i < @info; $i++) {
		$fndb = 0;
		$fndo = 0;
		$_ = $info[$i];
		$ost = $_;
		if($ost =~ s/Windows ([A-Za-z0-9. ]{2,8})//) { $os = "Windows $1"; }
		elsif($ost =~ s/Win([ 0-9.]{2,8})//) { $os = "Windows $1"; }
		elsif($ost =~ s/Linux([ 0-9.]{2,8})//) { $os = "Linux $1"; }
			else { $os = $var{'60'}; }
		if($ost =~ s/Opera ([0-9.A-Za-z]{2,9})// || $ost =~ s/Opera\/([0-9.A-Za-z]{2,9})//) { $browser = "Opera $1"; }
		elsif($ost =~ s/MSIE ([0-9.A-Za-z]{2,9})//) { $browser = "Microsoft Internet Explorer $1"; }
		elsif($ost =~ s/Netscape ([0-9.A-Za-z]{2,9})//) { $browser = "Netscape $1"; }
		elsif($ost =~ s/Gecko\/([0-9]{4})([0-9]{2})([0-9]{2})//) { $browser = "Gecko ($2.$3.$1)"; }
		elsif($ost =~ s/Gecko//) { $browser = "Gecko"; }
		elsif($ost =~ s/Mozilla\/([0-9.A-Za-z]{2,9})//) { $browser = "Mozilla $1"; }
		elsif($ost =~ s/PHP\/([0-9.A-Za-z]{2,9})//) { $browser = "PHP $1"; $os = "PHP $1"; }
		elsif($ost =~ s/bot//) { $browser = "Bot"; $os = "Bot"; }
			else { $browser = $var{'60'}; }
		if($os =~ s/NT 5.0//) { $os .= "2000"; }
		if($os =~ s/NT 5.1//) { $os .= "XP"; }
		if($os =~ s/NT 6.0//) { $os .= "Codename Longhorn"; }
		foreach (@osr) { if($os eq $_) { $fndo = 1; last; } }
		foreach (@tbro) { if($browser eq $_) { $fndb = 1; last; } }
		if(!$fndb) { push(@tbro,$browser); }
		if(!$fndo) { push(@osr,$os); }
		++$oscnt{$os};
		++$brcnt{$browser};
	}
	$oscnt = @osr;
	$browsercnt = @tbro;
	print <<"EOT";
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" class="catbg" colspan="6"><b>&#149; $admintxt[91] ($oscnt)</b></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" class="win2" colspan="6">
EOT
	foreach(sort @osr) {
		$percent = sprintf("%.2f",(($oscnt{$_}/$totalips)*100));
		print qq~  <font size="1" class="smalltext">$oscnt{$_} $admintxt[87] ($percent%)  -&#155;  </font>$_<br>\n~;
	}
	print <<"EOT";
  </td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" class="catbg" colspan="6"><b>&#149; $admintxt[92] ($browsercnt)</b></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" class="win2" colspan="6">
EOT
	foreach(sort @tbro) {
		$percent = sprintf("%.2f",(($brcnt{$_}/$totalips)*100));
		print qq~  <font size="1" class="smalltext">$brcnt{$_} $admintxt[87] ($percent%)  -&#155;  </font> $_<br>\n~;
	}
	for($i = 0; $i < @ref; $i++) {
		$fnd = 0;
		++$refers{$ref[$i]};
		foreach (@list) {
			if($_ eq "$ref[$i]") { $fnd = 1; last; }
		}
		if(!$fnd && $ref[$i] ne '') { push(@list,$ref[$i]); }
	}
	$refcnt = @list;
	print <<"EOT";
  </td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" class="catbg" colspan="6"><b>&#149; $admintxt[93] ($refcnt)</b></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" class="win2" colspan="6">
EOT
	$cnt = 0;
	foreach(@list) { print qq~<font size="1" class="smalltext">$refers{$_} $admintxt[87] -&#155; </font><a href="$_">$_</a><br>~; }
	if($list[0] eq '') { print "  $admintxt[94]\n"; }
	for($i = 0; $i < @page; $i++) {
		$fnd = 0;
		$page[$i] =~ s/^,//gsi;
		++$pv{"$page[$i]"};
		foreach (@nlist) {
			if($_ eq $page[$i]) { $fnd = 1; last; }
		}
		if(!$fnd && $page[$i] ne '') { push(@nlist,$page[$i]); }
	}
	$pagecnt = @nlist;
	print <<"EOT";
  </td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" class="catbg" colspan="6"><b>&#149; $admintxt[95]<font size="1" class="smalltext"> ($pagecnt, $admintxt[83])</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win" colspan="6">
EOT
	foreach(@nlist) { push(@nlists,"$pv{$_}|$_"); }

	foreach (sort{$b <=> $a} @nlists) {
		($hits,$page) = split(/\|/,$_);
		$percent = sprintf("%.2f",(($hits/$totalips)*100));
		if($page eq $admintxt[85]) { $vurl = ''; $vname = $admintxt[85]; } else { $vurl = $page; $vname = $page; }
		print qq~  <font size="1" class="smalltext">$hits $admintxt[87] ($percent%) -&#155; </font><a href="$rurl,$vurl">$vname</a><br>\n~;
	}
	if($page[0]) { print <<"EOT";
 <tr>
  <td bgcolor="$color{'catbg'}" class="catbg" align="center" colspan="6"><font size="1" class="smalltext"><a href="javascript:clear('$scripturl,v=admin,a=clicklog,p=delete')"><b>$admintxt[96]</b></a></font></td>
 </tr>
EOT
	}
	print <<"EOT";
  </td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub ErrorLog {
	if($URL{'p'} eq 'delete') {
		unlink("$prefs/ELog.txt");
		redirect("$scripturl,v=admin,r=3");
	}
	$title = $admintxt[117];
	&header;
	print <<"EOT";
<script language="javascript">
<!-- //
function clear(url) {
 if(window.confirm("$admintxt[80]")) { location = url; }
}
// -->
</script>
<table bgcolor="$color{'border'}" class="border" cellpadding="4" cellspacing="1" width="750" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg"><b><img src="$images/warning.gif"> $title</b></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win"><font size="1" class="smalltext">$admintxt[118]</font></td>
 </tr>
EOT

	fopen(FILE,"$prefs/ELog.txt");
	@elog = <FILE>;
	fclose(FILE);
	chomp @elog;
	if(!$elog[0] && $kelog) {
		print <<"EOT";
 <tr>
  <td align="center" bgcolor="$color{'win2'}" class="win2"><b>$admintxt[121]</b></td>
 </tr>
</table>
EOT
	} else {
		print "</table>";
		$clog = 1;
		foreach(reverse @elog) {
			($desc,$reason,$logtime,$lusername,$url) = split(/\|/,$_);
			loaduser($lusername);
			if($userset{$lusername}->[1] ne '') { $lusername = qq~<a href="$scripturl,v=memberpanel,a=view,u=$lusername">$userset{$lusername}->[1]</a>~; }
				else { $lusername = $lusername; }
			++$counter;
			$timeoferror = &get_date($logtime);
			$reason = $reason ne '?' ? $reason = qq~<tr><td bgcolor="$color{'win'}" class="win" colspan="2"><font size="1" class="smalltext"><b>$reason</font></td></tr>~ : '';
			print <<"EOT";
<br><table bgcolor="$color{'border'}" class="border" cellpadding="4" cellspacing="1" width="750" align="center">
 <tr>
  <td width="5%" bgcolor="$color{'win'}" class="win" align="center"><b>$counter</b></td>
  <td bgcolor="$color{'win'}" class="win" width="95%">
   <table width="100%">
    <tr>
     <td width="25%"><font size="1" class="smalltext"><b>$admintxt[180]:</b> $lusername</font></td>
     <td width="40%"><font size="1" class="smalltext"><b>$admintxt[181]:</b> $timeoferror</font></td>
     <td width="35%"><font size="1" class="smalltext"><a href="$url">$url</a></b></font></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" class="win2" colspan="2"><font size="1" class="smalltext">$desc</font></td>
 </tr>$reason
</table>
EOT
		}
	}


	if($clog) { print <<"EOT";
<br><table bgcolor="$color{'border'}" class="border" cellpadding="4" cellspacing="1" width="750" align="center">
 <tr>
  <td bgcolor="$color{'catbg'}" class="catbg" align="center"><font size="1" class="smalltext"><a href="javascript:clear('$scripturl,v=admin,a=errorlog,p=delete')"><b>$admintxt[96]</b></a></font></td>
 </tr>
</table>
EOT
	}

	&footer;
	exit;
}

sub IPLog {
	if($URL{'p'} eq 'delete') {
		unlink("$prefs/IpLog.txt");
		redirect("$scripturl,v=admin,r=3");
	}
	$clog = 1;

	$title = $admintxt[125];
	&header;
	print <<"EOT";
<script language="javascript">
<!-- //
function clear(url) {
 if(window.confirm("$admintxt[80]")) { location = url; }
}
// -->
</script>
<table bgcolor="$color{'border'}" class="border" cellpadding="4" cellspacing="1" width="750" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg" colspan="4"><b><img src="$images/login_sm.gif"> $title</b></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win" colspan="4"><font size="1" class="smalltext">$admintxt[126]</font></td>
 </tr>
EOT

	if(!$logip) { print <<"EOT";
 <tr>
  <td colspan="4" align="center" bgcolor="$color{'win'}" class="win"><b>$admintxt[120]</b></td>
 </tr>
EOT
		$clog = 0;
	}
		fopen(FILE,"$prefs/IpLog.txt");
		@iplog = <FILE>;
		fclose(FILE);
		if(!$iplog[0] && $logip == 1) { print <<"EOT";
 <tr>
  <td colspan="4" align="center" bgcolor="$color{'win'}" class="win"><b>$admintxt[131]</b></td>
 </tr>
EOT
		$clog = 0;
	} else {
		# Get Pages
		$mupp = 50;
		$maxmessages = @iplog || 1;
		if($maxmessages < $mupp) { $URL{'p'} = 0; }
		$tstart = $URL{'p'} || 0;
		$link = "$scripturl,v=admin,a=iplog,s=$URL{'s'},p";
		if($tstart > $maxmessages) { $tstart = $maxmessages; }
		$tstart = (int($tstart/$mupp)*$mupp);
		if($tstart > 0) { $bk = ($tstart-$mupp); $pagelinks = qq~<a href="$link=$bk">&#171;</a> ~; }
		$counter = 1;
		for($i = 0; $i < $maxmessages; $i += $mupp) {
			if($i == $tstart || $maxmessages < $mupp) { $pagelinks .= qq~<b>$counter</b>, ~; $nxt = ($tstart+$mupp); }
				else { $pagelinks .= qq~<a href="$link=$i">$counter</a>, ~; }
			++$counter;
		}
		$pagelinks =~ s/, \Z//gsi;
		if(($tstart+$mupp) != $i) { $pagelinks .= qq~ <a href="$link=$nxt">&#187;</a>~; }
		$end = ($tstart+$mupp);
		$pagelinks .= " ($var{'92'} $tstart-$end $var{'93'} ".@iplog.")";

		print <<"EOT";
 <tr>
  <td colspan="4" bgcolor="$color{'win2'}" class="win2"><font size="1" class="smalltext"><b><img src="$images/board.gif"> $gtxt{'17'}:</b> $pagelinks</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" class="catbg" align="center" width="25%"><font size="1" class="smalltext"><b>$admintxt[127]</b></font></td>
  <td bgcolor="$color{'catbg'}" class="catbg" align="center" width="20%"><font size="1" class="smalltext"><b>$admintxt[128]</b></font></td>
  <td bgcolor="$color{'catbg'}" class="catbg" align="center" width="25%"><font size="1" class="smalltext"><b>$gtxt{'18'}</b></font></td>
  <td bgcolor="$color{'catbg'}" class="catbg" align="center" width="30%"><font size="1" class="smalltext"><b>$admintxt[130]</b></font></td>
 </tr>
EOT
		@iplog = reverse @iplog;
		for($i = 0; $i < @iplog; ++$i) {
			if($i <= $end && $i > $tstart) { push(@log,$iplog[$i]); }
		}

		foreach(@log) {
			chomp;
			($lusername,$loginout,$ipaddr,$logtime) = split (/\|/,$_);
			&loaduser($lusername);
			if($userset{$lusername}->[1] eq '') { $userset{$lusername}->[1] = $lusername; }
				else { $userset{$lusername}->[1] = qq~<a href="$scripturl,v=memberpanel,a=view,u=$lusername">$userset{$lusername}->[1]</a>~; }
			$loginout = $loginout == 1 ? $admintxt[132] : $admintxt[133];
			$loggedtime = &get_date($logtime);
			print <<"EOT";
 <tr>
  <td bgcolor="$color{'win'}" class="win" align="center">$userset{$lusername}->[1]</td>
  <td bgcolor="$color{'win2'}" class="win2" align="center">$loginout</td>
  <td bgcolor="$color{'win'}" class="win" align="center">$ipaddr</td>
  <td bgcolor="$color{'win2'}" class="win2" align="center"><font size="1" class="smalltext">$loggedtime</font></td>
 </tr>
EOT
		}
		print <<"EOT";
 <tr>
  <td colspan="4" bgcolor="$color{'win'}" class="win"><font size="1" class="smalltext"><b><img src="$images/board.gif"> $gtxt{'17'}:</b> $pagelinks</font></td>
 </tr>
EOT
	}

	if($clog) { print <<"EOT";
 <tr>
  <td bgcolor="$color{'catbg'}" class="catbg" align="center" colspan="4"><font size="1" class="smalltext"><b><a href="javascript:clear('$scripturl,v=admin,a=iplog,p=delete')">$admintxt[96]</a></b></font></td>
 </tr>
EOT
	}

	print "</table>";
	&footer;
	exit;
}

sub Temp {
	fopen(FILE,"$root/template.html");
	while(<FILE>) {
		chomp $_;
		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
		$temps1 .= "$_\n";
	}
	fclose(FILE);

	fopen(FILE,"$prefs/Smilies.html");
	while(<FILE>) {
		chomp $_;
		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
		$temps2 .= "$_\n";
	}
	fclose(FILE);

	fopen(FILE,"$prefs/News.html");
	while(<FILE>) {
		chomp $_;
		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
		$temps3 .= "$_\n";
	}
	fclose(FILE);

	$title = $admintxt[135];
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" class="border" cellpadding="4" cellspacing="1" width="750" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg" colspan="2"><b><img src="$images/xx.gif"> $admintxt[135]</b></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win"><font size="1" class="smalltext">$admintxt[136]:<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i>&lt;blah v="</i><b>\$variable</b><i>"&gt;</i></font></td>
 </tr><tr><form action="$scripturl,v=admin,a=temp2" method="post" name="post">
  <td bgcolor="$color{'catbg'}" class="catbg" width="50%"><b><img src="$images/xx.gif"> $admintxt[137]</b></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" class="win2" align="center"><textarea rows="15" cols="140" name="temp1">$temps1</textarea></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" class="catbg" width="50%" colspan="2"><b><img src="$images/smiley.gif"> $admintxt[138]</b></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win" align="center" colspan="2"><textarea rows="15" cols="140" name="temp2">$temps2</textarea></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" class="catbg" width="50%" colspan="2"><b><img src="$images/news.gif"> $admintxt[182]</b></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" class="win2" align="center" colspan="2"><textarea rows="15" cols="140" name="temp3">$temps3</textarea></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win" align="center" colspan="2"><input type="submit" name="submit" value="$admintxt[139]"></td>
 </form></tr>
</table>
EOT

	&footer;
	exit;
}

sub Temp2 {
	fopen(FILE,"+>$root/template.html");
	print FILE $FORM{'temp1'};
	fclose(FILE);

	fopen(FILE,"+>$prefs/Smilies.html");
	print FILE $FORM{'temp2'};
	fclose(FILE);

	fopen(FILE,"+>$prefs/News.html");
	print FILE $FORM{'temp3'};
	fclose(FILE);
	redirect("$scripturl,v=admin,r=3");
}

sub Repop {
	if($URL{'p'} eq '') {
		$title = $admintxt[65];
		&header;
		print <<"EOF";
<table bgcolor="$color{'border'}" class="border" cellpadding="4" cellspacing="1" align="center" width="500">
 <tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg"><b><img src="$images/brd_main.gif"> $title</b></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win"><font size="1" class="smalltext">$admintxt[141]</font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" class="win2"><b><img src="$images/brd_main.gif"> <a href="$scripturl,v=admin,a=repop,p=start">$admintxt[142]</a></b><hr color="$color{'border'}" class="hr" size="1"><font size="1" class="smalltext"><img src="$images/warning_sm.gif"> $admintxt[143]</font></td>
 </tr>
</table>
EOF
		&footer;
		exit;
	}

	fopen(FILE,">$root/Maintance.lock"); # Start MM
	print FILE "\$maintance = 1;\n\$maintancer = qq~$admintxt[144]~;\n1;";
	fclose(FILE);

	foreach(@boardbase) {
		($cgs) = split("/",$_);
		fopen(FILE,"$boards/$cgs.msg");
		@msg = <FILE>;
		fclose(FILE);
		chomp @msg;
		$number = 0;
		$replycount = 0;
		@output = '';
		$puser = 0;
		$ptime = 0;
		foreach $msgs (@msg) {
			($tmess,$a,$b,$c,$replies,$poll,$f,$g) = split(/\|/,$msgs);
			$curnumber = -1;
			if($inu{$tmess}) { next; }
			if(!-s "$messages/$tmess.txt") { next; }
			fopen(FILE,"$messages/$tmess.txt");
			while( $countz = <FILE> ) {
				chomp $countz;
				($posted,$t,$t,$t,$lp) = split(/\|/,$countz);
				++$curnumber;
			}
			fclose(FILE);
			$replycount = $curnumber+$replycount;
			++$number;
			$inu{$tmess} = 1;
			if($poll && !$polltop) { # Count the polls
				fopen(FILE,"$messages/$tmess.polled");
				@last = <FILE>;
				fclose(FILE);
				chomp @last;
				$lloc = @last-1;
				($poller,$ptime) = split(/\|/,$last[$lloc]);
				if($ptime && $ptime > $lp) { $posted = $poller; $lp = $ptime; }
			}
			push(@output,"$lp|$tmess|$a|$b|$c|$curnumber|$poll|$f|$g|$posted");
		}
		$find = 0;
		fopen(FILE,"+>$boards/$cgs.msg");
		foreach $last (sort{$b <=> $a} @output) {
			($lp,$tmess,$a,$b,$c,$curnumber,$e,$f,$g,$posted) = split(/\|/,$last);
			if($find == 0) { $puser = $posted; $ptime = $lp; ++$find; }
			if($tmess eq '') { next; }
			print FILE "$tmess|$a|$b|$c|$curnumber|$e|$f|$g|$lp|$posted\n";
		}
		fclose(FILE);
		$replycount = $replycount+$number;
		fopen(FILE,"+>$boards/$cgs.ino");
		print FILE "$number\n$replycount\n";
		fclose(FILE);
	}
	unlink("$root/Maintance.lock"); # End MM
	if($URL{'a'} eq 'remove') { return; } # If removing old threads
	redirect("$scripturl,v=admin,r=2");
}

sub ManageBoards {
	CoreLoad('ManageForum');
	if($URL{'a'} eq 'cats') { &EditCatsR; }
		else {
			if($URL{'g'} eq '2') { &EditBoards2; }
			elsif($URL{'g'} eq '3') { &EditBoards3; }
			if($URL{'p'} eq 'move') { &MoveBoards; }
			if($URL{'p'} eq 'moveboard') { &MoveToCat; }
			&StartBoards;
		}
	exit;
}

sub Version {
	opendir(DIR,$code);
	@alldir = readdir(DIR);
	closedir(DIR);
	++$count;
	foreach(@alldir) {
		($good,$ext) = split(/\./,$_);
		$size += -s("$code/$_");
		fopen(FILE,"$code/$_");
		while(<FILE>) { ++$lines; }
		fclose(FILE);
		if($ext eq 'pl') { ++$count; }
	}
	fopen(FILE,"Blah.$scripttype");
	while(<FILE>) { ++$lines; }
	fclose(FILE);
	$size += -s("Blah.$scripttype");
	$lines = MakeComma($lines-(($count*11)-23));
	$size = sprintf("%.2f",($size/1024))." KB (".MakeComma($size)." bytes)";

	$bversion = $bversion < $theblahver ? qq~<font color="red"><b>$admintxt[179]</b></font>~ : $bversion;

	CoreLoad('Themes');

	$lngversion = $lngversion ? $lngversion : '2';

	$title = $admintxt[146];
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" class="border" cellpadding="4" cellspacing="1" width="500" align="center">
 <tr><form action="http://www.eblah.com/?v=check" method="post" name="check">
  <td bgcolor="$color{'titlebg'}" class="titlebg"><b><img src="$images/question.gif"> $title</b></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win"><font size="1" class="smalltext">$admintxt[147]</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" class="catbg"><b><img src="$images/open_thread.gif"> e-blah! $admintxt[148]</b></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" class="win2"><input type="hidden" name="version" value="$version"><table width="100%">
   <tr>
    <td align="right" width="150"><font size="1" class="smalltext"><b>$admintxt[153]:</b></font></td>
    <td><font size="1" class="smalltext">$size</font></td>
   </tr><tr>
    <td align="right" width="150"><font size="1" class="smalltext"><b>$admintxt[178]:</b></font></td>
    <td><font size="1" class="smalltext">$count</font></td>
   </tr><tr>
    <td align="right" width="150"><font size="1" class="smalltext"><b>$admintxt[177]:</b></font></td>
    <td><font size="1" class="smalltext">$lines</font></td>
   </tr></tr>
    <td colspan="2"><hr color="$color{'border'}" class="hr" size="1"></td>
   </tr><tr>
    <td align="right" width="150"><font size="1" class="smalltext"><b>$admintxt[149]:</b></font></td>
    <td><font size="1" class="smalltext">$version</font></td>
   </tr><tr>
    <td align="right" width="150"><font size="1" class="smalltext"><b>$admintxt[150]:</b></font></td>
    <td><font size="1" class="smalltext">$bversion</font></td>
   </tr><tr>
    <td align="right" width="150"><font size="1" class="smalltext"><b>$admintxt[151]:</b></font></td>
    <td><font size="1" class="smalltext">$themever &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; <b>$admintxt[152]:</b> $themesupp</font></td>
   </tr><tr>
    <td align="right" width="150"><font size="1" class="smalltext"><b>Language Pack:</b></font></td>
    <td><font size="1" class="smalltext">$lngversion</font></td>
   </tr></tr>
    <td colspan="2"><hr color="$color{'border'}" class="hr" size="1"></td>
   </tr><tr>
    <td align="right" width="150"><font size="1" class="smalltext"><b>Perl:</b></font></td>
    <td><font size="1" class="smalltext">$]</font></td>
   </tr><tr>
    <td align="right" width="150"><font size="1" class="smalltext"><b>Operating System:</b></font></td>
    <td><font size="1" class="smalltext">$^O</font></td>
   </tr>
  </table></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win"><input type="submit" value=" $admintxt[155] "></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub News {
	if($URL{'p'} == 2) {
		fopen(FILE,"+>$prefs/News.txt");
		print FILE "$FORM{'news'}";
		fclose(FILE);
		redirect("$scripturl,v=admin,r=3");
	}
	fopen(FILE,"$prefs/News.txt");
	@news = <FILE>;
	fclose(FILE);
	chomp @news;
	foreach(@news) { $news .= "$_\n"; }
	$title = $admintxt[49];
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" class="border" cellspacing="1" cellpadding="4" width="550" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg"><b><img src="$images/news.gif"> $title</b></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win"><font size="1" class="smalltext">$admintxt[157]</font></td>
 </tr><tr><form action="$scripturl,v=admin,a=news,p=2" method="post" name="msend">
  <td bgcolor="$color{'win2'}" class="win2" align="center"><textarea name="news" wrap="virtual" rows="8" cols="100">$news</textarea></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win"><input type="submit" value=" $admintxt[139] "></td>
 </form></tr>
</table>
EOT
	&footer;
	exit;
}

sub Reserve {
	if($FORM{'cnt'}) {
		for($i = 1; $i <= $FORM{'max'}; ++$i) {
			if($FORM{"del_$i"}) { next; }
			$search = Format($FORM{"search_$i"});
			push(@pdata,qq~$search|$FORM{"box_$i"}~);
		}
		if($FORM{'search_new'}) { push(@pdata,"$FORM{'search_new'}|$FORM{'box_new'}"); }

		fopen(FILE,">$prefs/Names.txt");
		foreach(@pdata) { print FILE "$_\n"; }
		fclose(FILE);
		redirect("$scripturl,v=admin,a=reserve");
	}

	$title = $admintxt[171];
	&header;
	print <<"EOT";
<table cellpadding="4" cellspacing="1" bgcolor="$color{'border'}" class="border" align="center" width="500">
 <tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg"><b><img src="$images/mem_main.gif"> $title</b></td>
 </tr><tr><form action="$scripturl,v=admin,a=reserve" method="POST">
  <td bgcolor="$color{'win'}" class="win"><font size="1" class="smalltext">$admintxt[172]</font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" class="win2">
   <table cellpadding="3" cellspacing="0" width="100%">
    <tr>
     <td width="44%"><font size="1" class="smalltext"><b>$admintxt[174]</b></font></td>
     <td width="44%" align="center"><font size="1" class="smalltext"><b>$admintxt[175]</b></font></td>
     <td width="12%" align="center"><font size="1" class="smalltext"><b>$admintxt[173]</b></font></td>
    </tr>
EOT
	$count = 0;
	fopen(FILE,"$prefs/Names.txt");
	while(<FILE>) {
		chomp $_;
		($searchme,$within) = split(/\|/,$_);
		$checked = $within ? ' checked' : '';
		++$count;
		print <<"EOT";
    <tr>
     <td width="44%"><input type="text" name="search_$count" value="$searchme" size="30"></td>
     <td width="44%" align="center"><input type="checkbox" name="box_$count" value="1"$checked></td>
     <td width="12%" align="center"><input type="checkbox" name="del_$count" value="1"></td>
    </tr>
EOT
	}
	if($count <= 0) {
		print <<"EOT";
    <tr>
     <td colspan="3" align="center"><font size="1" class="smalltext"><br>$admintxt[176]<br><br></font></td>
    </tr>
EOT
	}
	fclose(FILE);
	print <<"EOT";
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win">
   <table cellpadding="3" cellspacing="0" width="100%">
    <tr>
    <tr>
     <td width="44%"><input type="text" name="search_new" value="" size="30"></td>
     <td width="44%" align="center"><input type="checkbox" name="box_new" value="1"></td>
     <td width="12%"></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" class="win2" align="center"><input type="hidden" name="max" value="$count"><input type="hidden" name="cnt" value="1"><input type="submit" value=" $admintxt[139] "></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub BoardBackup { # Backup Routines
	$title = $admintxt[66];
	&header;
	print <<"EOT";
<script language="javascript1.2">
<!--
function togledisable() {
 for(i = 0; i < document.post.elements.length; i++) {
  if(document.post.elements[i].disabled == true || document.post.elements[i].name == "compress" || document.post.elements[i].name == "broot" || document.post.elements[i].name == "submit") { document.post.elements[i].disabled = false; }
   else { document.post.elements[i].disabled = true; }
 }
}
-->
</script>
<table bgcolor="$color{'border'}" class="border" cellpadding="4" cellspacing="1" width="500" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg" colspan="2"><b><img src="$images/open_thread.gif"> $title</b></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win"><font size="1" class="smalltext">$backupt[2]</font></td>
 </tr><form action="$scripturl,v=admin,a=bkupstart" method="post" name="post"><tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg"><b>$backupt[10]</b></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" class="win2">
   <table width="100%">
    <tr>
     <td align="right" width="50%" bgcolor="$color{'win2'}" class="win2"><b>$backupt[22]:</b></td>
     <td bgcolor="$color{'win2'}" class="win2" valign="top"><input type="text" value="backup" name="fname"></td>
    </tr><tr>
     <td align="right" width="50%" bgcolor="$color{'win2'}" class="win2"><b>$backupt[20]</b></td>
     <td bgcolor="$color{'win2'}" class="win2" valign="top"><input type="checkbox" value="1" name="broot" onClick="togledisable();" checked></td>
    </tr><tr>
     <td align="right" ><b>$backupt[21]</b></td>
     <td valign="top"><input type="checkbox" value="1" name="compress" checked></td>
    </tr>
   </table>
  </td>
 </tr>
 <tr>
  <td bgcolor="$color{'win'}" class="win">
   <table width="100%">
    <tr>
     <td width="50%" align="right"><b>Boards:</b></td>
     <td><input type="checkbox" value="1" name="boards" disabled></td>
    </tr><tr>
     <td align="right"><b>Members:</b></td>
     <td><input type="checkbox" value="1" name="members" disabled></td>
    </tr><tr>
     <td align="right"><b>Messages:</b></td>
     <td><input type="checkbox" value="1" name="messages" disabled></td>
    </tr><tr>
     <td align="right"><b>Prefs:</b></td>
     <td><input type="checkbox" value="1" name="prefs" disabled></td>
    </tr><tr>
     <td align="right"><b>Code:</b></td>
     <td><input type="checkbox" value="1" name="code" disabled></td>
    </tr><tr>
     <td align="right"><b>Themes:</b></td>
     <td><input type="checkbox" value="1" name="themes" disabled></td>
    </tr><tr>
     <td align="right"><b>Uploads:</b></td>
     <td><input type="checkbox" value="1" name="uploads" disabled></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" class="win2" align="right"><input type="submit" name="submit" value="$backupt[16]"></td>
 </form></tr>
</table>
EOT
	&footer;
	exit;
}

sub BKUPStart {
	$FORM{'fname'} =~ s/ /_/g;
	$FORM{'fname'} =~ s/[#%+,\\\/:?"<>'|@^\$\&~'\)\(\]\[\;{}!`=-]//g;
	if($FORM{'broot'}) {
		`tar -cf - "$root" > "./$FORM{'fname'}_full.tar"`;
		push(@compress,"./$FORM{'fname'}_full.tar");
	} else {
		if($FORM{'messages'}) {
			`tar -cf - "$messages" > "./$FORM{'fname'}_messages.tar"`;
			push(@compress,"./$FORM{'fname'}_messages.tar");
		}
		if($FORM{'code'}) {
			`tar -cf - "$code" > "./$FORM{'fname'}_code.tar"`;
			push(@compress,"./$FORM{'fname'}_code.tar");
		}
		if($FORM{'boards'}) {
			`tar -cf - "$boards" > "./$FORM{'fname'}_boards.tar"`;
			push(@compress,"./$FORM{'fname'}_boards.tar");
		}
		if($FORM{'prefs'}) {
			`tar -cf - "$prefs" > "./$FORM{'fname'}_prefs.tar"`;
			push(@compress,"./$FORM{'fname'}_prefs.tar");
		}
		if($FORM{'members'}) {
			`tar -cf - "$members" > "./$FORM{'fname'}_members.tar"`;
			push(@compress,"./$FORM{'fname'}_members.tar");
		}
		if($FORM{'uploads'}) {
			`tar -cf - "$uploads" > "./$FORM{'fname'}_uploads.tar"`;
			push(@compress,"./$FORM{'fname'}_uploads.tar");
		}
		if($FORM{'themes'}) {
			`tar -cf - "$themes" > "./$FORM{'fname'}_themes.tar"`;
			push(@compress,"./$FORM{'fname'}_themes.tar");
		}
	}

	if($FORM{'compress'}) {
		foreach(@compress) { `gzip $_`; }
	}

	redirect("$scripturl,v=admin,r=4");
}
1;