################################################
# E-Blah Bulliten Board Systems       Platinum #
################################################
# Copyright (c) 2001 - 2004 e-blah!            #
# All Rights Reserved.                         #
################################################

CoreLoad('Attach',1);

sub Upload {
	if($uallow == 0 && (!$avupload && $URL{'v'} ne 'profile')) { &error($atext[1]); }
	if($uallow == 2 && $username eq 'Guest') { &error($atext[55]); }
	if($uallow == 3 && $settings[4] ne 'Administrator') { &error($atext[56]); }
	$fname = lc($FORM{'ulfile'});
	$fname =~ s/.+\\([^\\]+)$|.+\/([^\/]+)$/$1/;
	$fname =~ s/^.*(\\|\/)//;
	$fname =~ s/ /_/g;
	$fname =~ s/[#%+,\\\/:?"<>'|@^\$\&~'\)\(\]\[\;{}!`=-]//g;
	if($fname eq '.htaccess') { &error($atext[5]); }

	$uploadz = new CGI;
	$file = $uploadz->param("ulfile");
	$tmpfile = $uploadz->tmpFileName($file);

	if($allowedext ne '') {
		$fnchk = $fname;
		$fnchk =~ s/(.+?)[(.)]/$2/gsi;

		@allowed = split(",",$allowedext);
		foreach(@allowed) {
			if($fnchk eq lc($_)) { $okay = 1; last; }
		}
		foreach(@allowed) { $aup .= "$_, "; }
		$aup =~ s/, \Z//i;
		if($okay != 1) { &error("$atext[2] $aup"); }
	}

	$savedfile = "$uploaddir/$fname";
	if(-e "$savedfile") { &error($atext[3]); }

	fopen(OUTFILE, ">$savedfile");
	if($ntsys) { binmode(OUTFILE); }
	while($bytesread = read($file,$buffers,1024)) { print OUTFILE $buffers; }
	fclose(OUTFILE);

	$savedsize = -s($savedfile);
	if($savedsize == 0) { unlink($savedfile); &error($atext[4]); }
	$savedsize = sprintf("%.2f",($savedsize/1024/1024));
	if($maxsize > 0) {
		if($maxsize < $savedsize) {
			unlink("$savedfile");
			$over = $savedsize-$maxsize;
			error($atext[5]);
		}
	}
	fopen(FILE,">$prefs/Hits/$fname.txt");
	print FILE "0";
	fclose(FILE);
	$atturl = "$fname";
	my $tttime = time;
	if($username eq 'Guest') { $temp1 = $ENV{'REMOTE_ADDR'}; } else { $temp1 = $username; }
	fopen(FILE,"+>>$prefs/Attachments.txt");
	print FILE "$atturl|$savedsize|$URL{'b'}|$URL{'m'}|$tttime|$temp1\n";
	fclose(FILE);
	if($uextlog) { ++$ExtLog[4]; }
	if($message =~ /\[upload\]/) { $message =~ s~\[upload\]~$uploadurl/$atturl~gsi; }

	unlink("$root/Blah.pl.core");
	&clear_temp;
}

sub clear_temp {
	if($filename) { close($filename); }

	if(-e($tmpfile)) {
		close($tmpfile);
		unlink($tmpfile) || error("Error deleting tempfile '$tmp': $!",1);
	}
}

sub Download {
	if(-e("$uploaddir/$URL{'f'}") == 0) { &error($atext[6]); }
	fopen(ADD,"+<$prefs/Hits/$URL{'f'}.txt");
	$nump = <ADD> || 0;
	seek(ADD,0,0);
	truncate(ADD,0);
	print ADD $nump+1,"\n";
	fclose(ADD);

	if($uextlog) { ++$ExtLog[5]; &ExtClose; }

	$title = $atext[64];
	&header;
	print <<"EOT";
<meta http-equiv="refresh" content="1;url=$uploadurl/$URL{'f'}">
<table bgcolor="$color{'border'}" class="border" cellspacing="1" cellpadding="4" width="400" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg"><b><img src="$images/open_thread.gif"> $title</b></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win"><font size="1" class="smalltext">$atext[61]</font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" class="win2" align="center"><br>$atext[62]<br><br><font size="1" class="smalltext"><a href="$uploadurl/$URL{'f'}">$atext[8]</a> $atext[63]</font><br><br></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub AttachLog {
	if($URL{'p'} eq 'del2' || $URL{'p'} eq 'del1') { &AttachLog2; }
	elsif($URL{'p'} eq 'extensive') { &AttachLog3; }
	elsif($URL{'p'} eq 'delete') { &AttachLog4; }

	if($uploaddir) {
		opendir(DIR,"$uploaddir/");
		@dirlist = readdir(DIR);
		closedir(DIR);
		$counter = 0;
		foreach(@dirlist) {
			chomp;
			$fsize = (-s "$uploaddir/$_");
			if($fsize == 0) { next; }
			$size = $size+$fsize;
			++$counter;
		}
		$size = sprintf("%.2f",$size/1024);
		$type = "KB";
		if($size > 1000) { $size = sprintf("%.2f",$size/1024); $type = "MB"; }
	}

	$title = $admintxt[69];
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" class="border" cellpadding="4" cellspacing="1" width="600" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg"><b><img src="$images/open_thread.gif"> $title</b></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win"><font size="1" class="smalltext">$admintxt[97]</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" class="catbg"><b>$admintxt[98]</b></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" class="win2">
   <table cellpadding="3" width="100%">
    <tr>
     <td align="right" width="40%"><b>$admintxt[99]:</b></td>
     <td width="60%">$counter</td>
    </tr><tr>
     <td align="right" width="40%"><b>$admintxt[100]:</b></td>
     <td width="60%">$size $type</td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" class="catbg"><b>$admintxt[101]</b></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win">
   <table cellpadding="2" width="100%">
    <tr><form action="$scripturl,v=admin,a=attlog,p=delete" method="post" name="send">
     <td><font size="1" class="smalltext"><b>&#155; $admintxt[104] <input type="text" name="days" value="60" maxlength="3" size="6"> $admintxt[102].</b>   <input type="submit" name="submit" value="$admintxt[106]"></font></td>
    </form></tr><tr><form action="$scripturl,v=admin,a=attlog,p=delete" method="post" name="send">
     <td><font size="1" class="smalltext"><b>&#155; $admintxt[105] <input type="text" name="kb" value="1024" maxlength="6" size="6"> KBs.</b>   <input type="submit" name="submit" value="$admintxt[106]"></font></td>
    </form></tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" class="win2">
   <table cellpadding="3" width="100%">
    <tr>
     <td><font size="1" class="smalltext"><b>  -&#155; <a href="$scripturl,v=admin,a=attlog,p=extensive">$admintxt[103]</a></b></font></td>
    </tr>
   </table>
  </td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub AttachLog3 {
	$title = $admintxt[107];
	&header;
	print <<"EOT";
<script language="javascript">
<!-- //
function clear(url) {
 if(window.confirm("$admintxt[108]")) { location = url; }
}
// -->
</script>
<table bgcolor="$color{'border'}" class="border" cellpadding="4" cellspacing="1" width="750" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg"><b><img src="$images/open_thread.gif"> $title</b></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" class="win"><font size="1" class="smalltext">$admintxt[109]</font></td>
 </tr>
EOT
	if($uploaddir) { # Open Uploads DIR
		opendir(DIR,"$uploaddir/");
		while ( $list = readdir(DIR) ) {
			if($list ne '.' && $list ne '..' && $list ne '.htaccess' && ($list =~ /\Q$FORM{'search'}\E/)) { push(@dirlist,$list); }
		}
		closedir(DIR);
	}
	if(!$dirlist[0]) { # 0 Uploads, exit.
		print <<"EOT";
 <tr>
  <td align="center" bgcolor="$color{'win2'}" class="win2"><b>$admintxt[116]</b></td>
 </tr>
</table>
EOT
		&footer;
		exit;
	}

	# Get Pages
	$mupp = 50;
	$maxuploads = @dirlist || 1;
	if($maxuploads < $mupp) { $URL{'s'} = 0; }
	$tstart = $URL{'s'} || 0;
	$counter = 1;
	$link = "$scripturl,v=admin,a=attlog,p=extensive,s";
	if($tstart > $maxuploads) { $tstart = $maxuploads; }
	$tstart = (int($tstart/$mupp)*$mupp);
	if($tstart > 0) { $bk = ($tstart-$mupp); $pagelinks = qq~<a href="$link=$bk">&#171;</a> ~; }
	for($i = 0; $i < $maxuploads; $i += $mupp) {
		if($i == $tstart || $maxuploads < $mupp) { $pagelinks .= qq~<b>$counter</b>, ~; $nxt = ($tstart+$mupp); }
			else { $pagelinks .= qq~<a href="$link=$i">$counter</a>, ~; }
		++$counter;
	}
	$pagelinks =~ s/, \Z//gsi;
	if(($tstart+$mupp) != $i) { $pagelinks .= qq~ <a href="$link=$nxt">&#187;</a>~; }
	$end = ($tstart+$mupp);
	$pagelinks .= " ($var{'92'} $tstart-$end $var{'93'} ".@dirlist." $admintxt2[218])";

	print <<"EOT";
 <tr><form action="$scripturl,v=admin,a=attlog,p=extensive" method="post" name="msend" enctype="multipart/form-data">
  <td bgcolor="$color{'win2'}" class="win2"><font size="1" class="smalltext"><b>$atext[59]: <input type="input" name="search" value="$FORM{'search'}" size="30"> <input type="submit" value="$atext[59]"></b><br>$atext[60]</font></td>
 </tr></form><tr>
  <td bgcolor="$color{'catbg'}" class="catbg"><font size="1" class="smalltext"><b>$gtxt{'17'}:</b> $pagelinks</font></td>
 </tr>
EOT
	# Check for File Location
	fopen(FILE,"$prefs/Attachments.txt"); # Get Thread ID Location
	@attlog = <FILE>;
	fclose(FILE);
	chomp @attlog;
	foreach(@attlog) {
		($aname,$t,$aboard,$amess,$atime,$auser) = split(/\|/,$_);
		$fname{$aname} = "$amess|$auser";
	}
	foreach(@boardbase) { # Search For it
		($open) = split("/",$_);
		fopen(FILE,"$boards/$open.msg");
		while($tr = <FILE>) {
			($id,$sub) = split(/\|/,$tr);
			$mdat{$id} = "$sub|$open";
		}
		fclose(FILE);
	}

	$counter = 0;
	@dirlist = sort{lc($a) cmp lc($b)} @dirlist;
	for($c = 0; $c < @dirlist; $c++) {
		if($c >= $tstart && $c < $end) { push(@list,$dirlist[$c]); }
	}
	@colors = (qq~$color{'win'}" class="win"~,qq~$color{'win2'}" class="win2"~);
	foreach(@list) {
		$color = $colors[$counter % 2];
		++$counter;
		$size = (-s"$uploaddir/$_");
		$size = sprintf("%.2f",$size/1024);
		$type = "KB";
		if($size > 1000) { $size = sprintf("%.2f",$size/1024); $type = "MB"; }
		$fdate = (stat("$uploaddir/$_"))[9];
		$fdate = get_date($fdate);

		fopen(FILE,"$prefs/Hits/$_.txt");
		@nump = <FILE>;
		fclose(FILE);
		chomp @nump;
		$downloads = $nump[0] || 0;

		$visit = '';
		if($fname{$_}) {
			($amess,$auser) = split(/\|/,$fname{$_});
			($subject,$aboard) = split(/\|/,$mdat{$amess});
			$message = qq~<a href="$surl,b=$aboard,v=display,m=$amess">$subject</a>~;
			loaduser($auser);
			if($userset{$auser}->[1]) { $posted = qq~<a href="$scripturl,v=memberpanel,a=view,u=$auser">$userset{$auser}->[1]</a>~; } else { $posted = $auser; }
			if($posted ne '') { $visit = qq~ <tr>
  <td></td>
  <td align="right"><font size="1" class="smalltext"><b>$admintxt2[214]:</b></font></td>
  <td><font size="1" class="smalltext">$posted</font></td>
 </tr>~; }
			if($subject ne '') { $visit .= qq~ <tr>
  <td></td>
  <td align="right"><font size="1" class="smalltext"><b>$admintxt2[215]:</b></font></td>
  <td><font size="1" class="smalltext"><a href="$surl,b=$aboard,v=display,m=$amess" target="_new">$subject</a></font></td>
 </tr>~; }
		}

		if($_ =~ /(jpg|jpeg|gif|art|bmp|png)/) {
			$downloads = $downloads+1;
			fopen(ADD,"+>$prefs/Hits/$_.txt");
			print ADD $downloads,"\n";
			fclose(ADD);
			$picture = qq~<img src="$uploadurl/$_" border="0" width="100">~;
		} else { $picture = ''; }

		print <<"EOT";
 <tr>
  <td bgcolor="$color">
   <table cellpadding="0" cellspacing="0" width="100%">
    <tr>
     <td valign="top">
      <table>
       <tr>
        <td><img src="$images/board.gif"></td>
        <td colspan="2"><font size="1" class="smalltext"><b><a href="$scripturl,v=download,d=1,f=$_" target="download">$_</a></b></font></td>
       </tr><tr>
        <td></td>
        <td align="right"><font size="1" class="smalltext"><b>$admintxt2[213]:</b></font></td>
        <td><font size="1" class="smalltext">$fdate</font></td>
       </tr><tr>
        <td></td>
        <td align="right"><font size="1" class="smalltext"><b>$admintxt[111]:</b></font></td>
        <td><font size="1" class="smalltext">$size $type</font></td>
       </tr><tr>
        <td></td>
        <td align="right"><font size="1" class="smalltext"><b>$gtxt{'14'}:</b></font></td>
        <td><font size="1" class="smalltext">$downloads</font></td>
       </tr>$visit<tr>
        <td></td>
        <td colspan="2"><font size="1" class="smalltext"><b><a href="$scripturl,v=download,d=1,f=$_" target="download">$atext[57]</a> | <a href="javascript:clear('$scripturl,v=admin,a=attlog,p=del1,f=$_')">$atext[58]</a></b></font></td>
       </tr>
      </table>
     </td><td valign="center" align="center">$picture</td>
    </tr>
   </table>
  </td>
 </tr>
EOT
	}

	print <<"EOT";
 <tr>
  <td bgcolor="$color{'catbg'}" class="catbg"><font size="1" class="smalltext"><b>$gtxt{'17'}:</b> $pagelinks</font></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub AttachLog4 {
	opendir(DIR,"$uploaddir/");
	@dirlist = readdir(DIR);
	closedir(DIR);
	$counter = 0;
	if($FORM{'days'}) {
		$maxdays = ($FORM{'days'}*86400);
		$great = time-$maxdays;
	}
	$deleted = 0;
	foreach(@dirlist) {
		chomp;
		if($_ eq '.' || $_ eq '..') { next; }
		$fsize = sprintf("%.2f",((-s "$uploaddir/$_"))/1024);
		$fdate = (stat("$uploaddir/$_"))[9];
		if($FORM{'days'} && $fdate < $great) {
			++$deleted;
			push(@remove,$_);
		}
		if($FORM{'kb'} && $FORM{'kb'} < $fsize) {
			++$deleted;
			push(@remove,$_);
		}
		if($fsize == 0) { next; }
		$size = $size+$fsize;
		++$counter;
	}

	foreach(@remove) { unlink("$uploaddir/$_","$prefs/Hits/$_.txt"); }
	fopen(FILE,"$prefs/Attachments.txt");
	@att = <FILE>;
	fclose(FILE);
	chomp @att;
	fopen(FILE,"+>$prefs/Attachments.txt",1);
	foreach(@att) {
		$next = 0;
		($fnamez) = split(/\|/,$_);
		foreach $ds (@remove) {
			if($fnamez eq $ds) { $next = 1; next; }
		}
		if($next) { next; }
		print FILE "$_\n";
	}
	fclose(FILE);
	return;
}

sub AttachLog2 {
	unlink("$uploaddir/$URL{'f'}");
	unlink("$prefs/Hits/$URL{'f'}.txt");
	fopen(FILE,"$prefs/Attachments.txt");
	@att = <FILE>;
	fclose(FILE);
	fopen(FILE,"+>$prefs/Attachments.txt",1);
	foreach (@att) {
		chomp;
		($fnamez) = split(/\|/,$_);
		if($fnamez ne $URL{'f'}) { print FILE "$_\n"; }
	}
	fclose(FILE);
	redirect("$scripturl,v=admin,a=attlog,p=extensive");
}
1;